#include "ros/ros.h"
{% for d in data %}
#include "{{ pkgname }}/Get{{ d.name| capitalize }}Data.h"
{% if d.type in typemap %}{% else %}{% do typemap.update({d.type: d.type}) %}{% endif %}
{% endfor %}

class {{ skillset|capitalize }}DataManager {
private:
  {% for d in data %}// {{ d.name  }} data
  {{ typemap[d.type]|cpp_type }} {{ d.name }}_;
  bool {{ d.name }}_received_;
  ros::Subscriber {{ d.name }}_subscriber_;
  ros::ServiceServer {{ d.name }}_service_;
  {% endfor %}
  {% for d in data %}
  void {{ d.name }}_callback(const {{ typemap[d.type]|cpp_type }} &msg)
  {
    ROS_DEBUG("[data_manager] received data {{ d.name }}");
    this->{{ d.name }}_received_ = true;
    this->{{ d.name }}_ = msg;
  }

  bool get_{{ d.name }}_callback({{ pkgname }}::Get{{ d.name| capitalize }}Data::Request& request, {{ pkgname }}::Get{{ d.name| capitalize }}Data::Response& response)
  {
    (void)request; // remove unused warning
    if (this->{{ d.name }}_received_) {
      response.data = this->{{ d.name }}_;
      return true;
    }
    else return false;
  }
  {% endfor %}

public:
  {{ skillset|capitalize }}DataManager() {
    ros::NodeHandle n;
    {% for d in data %}
    this->{{ d.name }}_received_ = false;
    this->{{ d.name }}_subscriber_ = n.subscribe("data/{{ d.name }}", 1,
      &{{ skillset|capitalize }}DataManager::{{ d.name }}_callback, 
      this);
    this->{{ d.name }}_service_ = n.advertiseService("data/get_{{ d.name }}", &{{ skillset|capitalize }}DataManager::get_{{ d.name }}_callback, this);
    {% endfor %}
  }

};

int main(int argc, char **argv)
{
  ros::init(argc, argv, "data_manager");
  ros::NodeHandle n;
  {{ skillset|capitalize }}DataManager rm;
  ROS_INFO("[data_manager] Data Manager ready");
  ros::spin();
  return 0;
}
